from portal.database.models import Submission, SubmissionState
from portal.tools.time import NOW
from datetime import timedelta


def can_create_submission(user, project, conflict_timeout) -> bool:
    conflict = Submission.query.filter(Submission.state != SubmissionState.FINISHED, Submission.project == project,
                                       Submission.user == user).first()
    if not conflict:
        return True
    if (conflict.created_at + conflict_timeout) <= NOW:
        conflict.state = SubmissionState.FAILED
        conflict.note += f"FAILED at {NOW}: processing timed out (unprocessed in {conflict_timeout})."
        # stop processing... notify Queue, Kontr?
        return True
    return False


def schedule_submission(scheduler_config):
    # stub
    return NOW + timedelta(minutes=5)
